using Encompass;
using KavTest.Components;
using KavTest.Messages;
using Microsoft.Xna.Framework;

namespace KavTest.Spawners
{
    public class BillboardSpriteSpawner : Spawner<BillboardSpriteSpawnMessage>
    {
        protected override void Spawn(in BillboardSpriteSpawnMessage message)
        {
            var entity = CreateEntity();

            var transform = new Transform3D(
                message.Position,
                Quaternion.Identity,
                new Vector3(message.Scale, 1)
            );

            AddComponent(entity, new Transform3DComponent(transform));
            AddComponent(entity, new SpriteComponent(message.Texture, message.Origin));
            AddComponent(entity, new AngularVelocityComponent(new Vector3(2f, 0, 0)));
        }
    }
}
